# sc::Convergence Class Reference

The Convergence class is used by the optimizer to determine when an optimization is converged. More...

`#include <conv.h>`

Inheritance diagram for sc::Convergence:

List of all members.

## Public Member Functions
| Convergence (double tolerance)
| Convergence (StateIn &)
| Convergence (const Ref< KeyVal > &)
| The KeyVal constructor reads the following keywords:
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.
virtual void | get_grad (const Ref< Function > &)
| Set the current gradient and displacement.
virtual void | get_x (const Ref< Function > &)
virtual void | set_nextx (const RefSCVector &)
virtual void | reset ()
| Set the current gradient and displacement to null.
virtual int | converged ()
| Return nonzero if the optimization has converged.
## Protected Member Functions
void | check_conv (const char *heading, double val, double bound, int &pass, int &fail)
void | set_defaults ()
## Protected Attributes
RefSCVector | grad_
RefSCVector | x_
RefSCVector | nextx_
int | use_max_disp_
double | max_disp_
int | use_max_grad_
double | max_grad_
int | use_rms_disp_
double | rms_disp_
int | use_rms_grad_
double | rms_grad_
int | use_graddisp_
double | graddisp_

## Detailed Description

The Convergence class is used by the optimizer to determine when an optimization is converged.

The KeyVal input for Convergence is given below. Giving none of these keywords is the same as giving the following input:

      conv<Convergence>: (
        max_disp = 1.0e-6
        max_grad = 1.0e-6
        graddisp = 1.0e-6
      )

## Constructor & Destructor Documentation

sc::Convergence::Convergence | ( | const Ref< KeyVal > & |  | ) |

The KeyVal constructor reads the following keywords:

`max_disp`

  The value of the maximum displacement must be less then the value of this keyword for the calculation to be converged. The default is to not check this parameter. However, if no other keyword are given, default convergence parameters are chosen as described above.

`max_grad`

  The value of the maximum gradient must be less then the value of this keyword for the calculation to be converged. The default is to not check this parameter. However, if no other keyword are given, default convergence parameters are chosen as described above.

`rms_disp`

  The value of the RMS of the displacements must be less then the value of this keyword for the calculation to be converged. The default is to not check this parameter. However, if no other keyword are given, default convergence parameters are chosen as described above.

`rms_grad`

  The value of the RMS of the gradients must be less then the value of this keyword for the calculation to be converged. The default is to not check this parameter. However, if no other keyword are given, default convergence parameters are chosen as described above.

`graddisp`

  The value of the scalar product of the gradient vector with the displacement vector must be less then the value of this keyword for the calculation to be converged. The default is to not check this parameter. However, if no other keyword are given, default convergence parameters are chosen as described above.

## Member Function Documentation

void sc::Convergence::save_data_state | ( | StateOut & |  | ) | `[virtual]`

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::SavableState.

Reimplemented in sc::MolEnergyConvergence.

The documentation for this class was generated from the following file:

- conv.h